"use strict";
/**
 * Copyright (c) 2018-present, tarant
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const message_1 = tslib_1.__importDefault(require("../mailbox/message"));
const actor_1 = tslib_1.__importDefault(require("./actor"));
const actor_message_1 = tslib_1.__importDefault(require("./actor-message"));
class ActorProxy {
    static sendAndReturn(mailbox, actorId, methodName, args) {
        return new Promise((resolve, reject) => mailbox.push(message_1.default.of(actorId, actor_message_1.default.of(methodName, args, resolve, reject))));
    }
    static of(mailbox, actor) {
        let allNames = [];
        for (let o = actor; o && o !== actor_1.default.prototype; o = Object.getPrototypeOf(o)) {
            allNames = allNames.concat(Object.getOwnPropertyNames(o).filter((a) => typeof o[a] === 'function' && a !== 'constructor'));
        }
        return allNames
            .map((name) => [
            name,
            (...args) => ActorProxy.sendAndReturn(mailbox, actor.id, name, args),
        ])
            .reduce((result, [member, method]) => (Object.assign(Object.assign({}, result), { [member]: method })), { ref: actor });
    }
}
exports.default = ActorProxy;
