/**
 * Copyright (c) 2018-present, tarant
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import Mailbox from '../../mailbox/mailbox';
import ActorMessage from '../actor-message';
import IMaterializer from '../materializer/materializer';
import IResolver from '../resolver/resolver';
import IActorSupervisor from '../supervision/actor-supervisor';
import ActorSystemConfiguration from './actor-system-configuration';
export default class ActorSystemConfigurationBuilder {
    static define(): ActorSystemConfigurationBuilder;
    materializers: IMaterializer[];
    resolvers: IResolver[];
    resources: string[];
    tickInterval: number;
    mailbox: Mailbox<ActorMessage>;
    supervisor: IActorSupervisor;
    withMaterializers(materializers: IMaterializer[]): ActorSystemConfigurationBuilder;
    withResolvers(resolvers: IResolver[]): ActorSystemConfigurationBuilder;
    withResources(resources: [string]): ActorSystemConfigurationBuilder;
    withTickInterval(tickInterval: number): ActorSystemConfigurationBuilder;
    withMailbox(mailbox: Mailbox<ActorMessage>): ActorSystemConfigurationBuilder;
    withTopSupervisor(supervisor: IActorSupervisor): ActorSystemConfigurationBuilder;
    done(): ActorSystemConfiguration;
}
