"use strict";
/**
 * Copyright (c) 2018-present, tarant
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const actor_1 = tslib_1.__importDefault(require("../actor"));
class FunctionActor extends actor_1.default {
    static for(system, fn) {
        const actor = system.actorOf(FunctionActor, [fn]);
        // tslint:disable-next-line
        return function () {
            return actor.execute(...arguments);
        };
    }
    constructor(fn) {
        super();
        this.fn = fn;
    }
    execute(...args) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return yield this.fn(...args);
        });
    }
}
exports.default = FunctionActor;
