/**
 * Copyright (c) 2018-present, tarant
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import Message from './message';
import ISubscriber from './subscriber';
export default class Mailbox<T> {
    static empty<T>(): Mailbox<T>;
    private readonly subscribedPartitions;
    private readonly subscriptions;
    addSubscriber(subscriber: ISubscriber<T>): string;
    removeSubscription(subscription: string): void;
    push(message: Message<T>): void;
    poll(subscription: string): Promise<void>;
}
