"use strict";
/**
 * Copyright (c) 2018-present, tarant
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
class Subscription {
    constructor(id, subscriber) {
        this.messages = [];
        this.id = id;
        this.subscriber = subscriber;
    }
    process() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const message = this.messages[0];
            if (message) {
                if (yield this.subscriber.onReceiveMessage(message)) {
                    this.messages.splice(0, 1);
                }
            }
        });
    }
}
exports.default = Subscription;
